var imgview;
var ctx;
var simpleGui;

var trades = [[["Изумруд-деньги", 388, 1],["Стейк", 364, 6]],[["Изумруд-деньги", 388, 1],["Жаренная свинина", 320, 6]],[["Изумруд-деньги", 388, 1],["Железный нагрудник", 306, 1]],[["Изумруд-деньги", 388, 2],["Iron Chestplate", 307, 1]],[["Изумруд-деньги", 388, 2],["Iron Leggin", 308, 1]],[["Изумруд-деньги", 388, 1],["Iron Boots", 309, 1]],[["Изумруд-деньги", 388, 6],["Saddle", 329, 1]],[["Raw Beef", 363, 14],["Изумруд-деньги", 388, 1]],[["Raw Porkchop", 319, 14],["Изумруд-деньги", 388, 1]],[["Coal", 263, 15],["Изумруд-деньги", 388, 1]],[["Gold Ingot", 266, 5],["Изумруд-деньги", 388, 1]],[["Изумруд-деньги", 388, 1],["Яблоко", 260, 10]],[["Изумруд-деньги", 388, 1],["Хлебушек-сладкий", 297, 5]],[["Изумруд-деньги", 388, 1],["Жаренная курятина", 366, 7]],[["Изумруд-деньги", 388, 1],["Печенька", 357, 5]],[["Изумруд-деньги", 388, 1],["Melon", 360, 5]],[["Изумруд-деньги", 388, 1],["Arrow", 262, 10]],[["Изумруд-деньги", 388, 1],["Зажигалка", 259, 1]],[["Изумруд-деньги", 388, 18],["Ножницы", 359, 1],[["Изумруд-деньги", 388, 1],["Flint", 318, 4]],[["Сырая курятина", 365, 14],["Изумруд-деньги", 388, 1]],[["Пшеница", 296, 15],["Изумруд-деньги", 388, 1]],[["Шерсть", 35, 15],["Изумруд-деньги", 388, 1]],[["Золотой слиток", 266, 5],["Изумруд-деньги", 388, 1]]]];

function newLevel() { //load world	
	ctx = com.mojang.minecraftpe.MainActivity.currentMainActivity.get();
}

function leaveGame() { //exit world
	if(ctx!=null) {
		ctx.runOnUiThread(new java.lang.Runnable({ run: function() {
			try{
				if(simpleGui != null) {
					simpleGui.dismiss();
					simpleGui = null;
				}
			}catch(err){
				print("Error: " + err);
			}
		}}));
	}
}

function attackHook(attacker, victim) {
	if (Entity.getEntityTypeId(victim) == 15) { //player attacked a villager
        Entity.setHealth(victim, Entity.getHealth(victim)+1); //restore health back to normal (presumes player hit villager with empty hand and not sword, etc)
		showTradeGui();
    }
}

function showTradeGui(){
	if (simpleGui == null) { //don't allow multiple simpleGuis to be opened
		ctx.runOnUiThread(new java.lang.Runnable({ run: function() {
			try{
				simpleGui = new android.widget.PopupWindow();
				var layout = new android.widget.LinearLayout(ctx);
				layout.setBackgroundColor(android.graphics.Color.GRAY);
				layout.setOrientation(android.widget.LinearLayout.VERTICAL);
				
							

				var tradeText = new android.widget.TextView(ctx);
				tradeText.setGravity(android.view.Gravity.CENTER);
				
				var rnd = Math.floor(Math.random()*(trades.length)); //(pseudo) random number between 0 and trades.length-1 (inclusive; that means 0 and trades.length-1 could be the number returned)
				tradeText.setText("За " + trades[rnd][0][2] + " " + trades[rnd][0][0] + " Я дам тебе " + trades[rnd][1][2] + " " + trades[rnd][1][0]);
				
				layout.addView(tradeText);	
				
				var tradeButton = new android.widget.Button(ctx);
				tradeButton.setText("Торговать");
				tradeButton.setOnClickListener(new android.view.View.OnClickListener() {
					onClick: function(v) {
						if (Level.getGameMode() == 1 || invContains(trades[rnd][0][1], trades[rnd][0][2])) { //if the player is in creative mode or has enough of the required item to trade
							var deduct = invDeduct(trades[rnd][0][1], trades[rnd][0][2]);
							print(deduct);
							Player.addItemInventory(trades[rnd][1][1], trades[rnd][1][2], 0);
							print("Обменялись!");
						} else {
							print("У тебя нет денег $$$.");
						}
						simpleGui.dismiss();
						simpleGui = null;
					}
				});
				
				layout.addView(tradeButton);
				
				var closeButton = new android.widget.Button(ctx);
				closeButton.setText("Закрыть");
				closeButton.setOnClickListener(new android.view.View.OnClickListener() {
					onClick: function(v) {
						simpleGui.dismiss();
						simpleGui = null;
					}
				});
				
				layout.addView(closeButton);
				
				simpleGui.setHeight(android.widget.LinearLayout.LayoutParams.WRAP_CONTENT);
				simpleGui.setWidth(android.widget.LinearLayout.LayoutParams.WRAP_CONTENT);

				simpleGui.setContentView(layout);
				simpleGui.showAtLocation(ctx.getWindow().getDecorView(), android.view.Gravity.CENTER, 0, 0);
			}catch(err){
				print("Error: "+err);
			}
		} }));
	} else {
		print("Доторгуйте сначала!.");
	}
}

function invContains(itemId, count) {
	var hasItem = false; //presume the player doesn't have the item
	
	for (var i = 0; i < 36; i++) {
		if (Player.getInventorySlot(i) == itemId && Player.getInventorySlotCount(i) >= count) {
			hasItem = true;
			break; //break the loop early if the item is found and the count is good
		}
	}
	
	return hasItem;
}

function invDeduct(itemId, count) {
	var didDeduct = false; //presume we didn't deduct
	
	for (var i = 0; i < 36; i++) {
		if (Player.getInventorySlot(i) == itemId && Player.getInventorySlotCount(i) >= count) {
			var remainder = Player.getInventorySlotCount(i) - count;
			Player.clearInventorySlot(i);
			Player.addItemInventory(itemId, remainder, 0);
			//net.zhuoweizhang.mcpelauncher.ScriptManager.nativeSetInventorySlot(i, itemId, Player.getInventorySlotCount(i) - count, 0);
			didDeduct = true;
			break; //break the loop early if the item has been deducted
		}
	}
	
	return didDeduct;
}